import { __extends, __spread, __read } from 'tslib';
import { Observable, merge, BehaviorSubject } from 'rxjs';
import { DataSource } from '@angular/cdk/table';
import { EventEmitter } from '@angular/core';
import { map } from 'rxjs/operators';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
//import { ErrorDialog } from '../error/error-dialog.component';
/** @type {?} */
var TAG = 'TableDataSource';
/**
 * @abstract
 * @template E
 */
var  /**
 * @abstract
 * @template E
 */
TableDataSource = /** @class */ (function (_super) {
    __extends(TableDataSource, _super);
    function TableDataSource() {
        //errorSubject: BehaviorSubject<Error> = new BehaviorSubject<Error>();
        var _this = _super !== null && _super.apply(this, arguments) || this;
        //statusEvent = new EventEmitter<string>();
        _this.errorEvent = new EventEmitter();
        _this.showSpinner = true;
        return _this;
    }
    /**
     *  Called when the table is being destroyed. Use this function, to clean up
     * any open connections or free any held resources that were set up during connect.
     */
    /**
     *  Called when the table is being destroyed. Use this function, to clean up
     * any open connections or free any held resources that were set up during connect.
     * @return {?}
     */
    TableDataSource.prototype.disconnect = /**
     *  Called when the table is being destroyed. Use this function, to clean up
     * any open connections or free any held resources that were set up during connect.
     * @return {?}
     */
    function () {
        if (this.errorEvent)
            this.errorEvent.complete();
    };
    /**
     * overload to provide post load filtering
     */
    // noinspection JSMethodCanBeStatic
    /**
     * overload to provide post load filtering
     * @protected
     * @param {?} data
     * @return {?}
     */
    // noinspection JSMethodCanBeStatic
    TableDataSource.prototype.filterData = /**
     * overload to provide post load filtering
     * @protected
     * @param {?} data
     * @return {?}
     */
    // noinspection JSMethodCanBeStatic
    function (data) {
        return data;
    };
    // noinspection JSMethodCanBeStatic
    // noinspection JSMethodCanBeStatic
    /**
     * @protected
     * @param {?} filter
     * @param {?} paginator
     * @return {?}
     */
    TableDataSource.prototype.applyPaginator = 
    // noinspection JSMethodCanBeStatic
    /**
     * @protected
     * @param {?} filter
     * @param {?} paginator
     * @return {?}
     */
    function (filter, paginator) {
        if (filter && paginator) {
            filter.pager = {
                firstResult: (paginator.pageIndex || 0) * paginator.pageSize,
                pageSize: paginator.pageSize
            };
        }
    };
    // noinspection JSMethodCanBeStatic
    // noinspection JSMethodCanBeStatic
    /**
     * @protected
     * @param {?} filter
     * @param {?} sort
     * @return {?}
     */
    TableDataSource.prototype.applySort = 
    // noinspection JSMethodCanBeStatic
    /**
     * @protected
     * @param {?} filter
     * @param {?} sort
     * @return {?}
     */
    function (filter, sort) {
        if (filter) {
            if (sort && sort.active) {
                filter.orderDir = sort.direction ? sort.direction.toUpperCase() : "ASC";
                filter.orderBy = sort.active;
            }
            if (filter.orderBy) {
                filter.orderBy = filter.orderBy.trim();
                if (filter.orderBy == '')
                    delete filter.orderBy;
            }
        }
    };
    // noinspection JSMethodCanBeStatic
    // noinspection JSMethodCanBeStatic
    /**
     * @protected
     * @param {?} filter
     * @param {?=} value
     * @return {?}
     */
    TableDataSource.prototype.applyKeyword = 
    // noinspection JSMethodCanBeStatic
    /**
     * @protected
     * @param {?} filter
     * @param {?=} value
     * @return {?}
     */
    function (filter, value) {
        if (filter && value) {
            filter.keyword = value;
        }
    };
    /**
     * @protected
     * @param {?} e
     * @param {?=} op
     * @param {?=} component
     * @return {?}
     */
    TableDataSource.prototype.onError = /**
     * @protected
     * @param {?} e
     * @param {?=} op
     * @param {?=} component
     * @return {?}
     */
    function (e, op, component) {
        if (component === void 0) { component = this.constructor.name; }
        this.status = 'error';
        e.error = Object.assign({ operation: op, component: component }, e.error);
        console.warn(TAG, 'Error loading data', op, e);
        this.errorEvent.emit(e);
    };
    return TableDataSource;
}(DataSource));
if (false) {
    /** @type {?} */
    TableDataSource.prototype.status;
    /** @type {?} */
    TableDataSource.prototype.errorEvent;
    /** @type {?} */
    TableDataSource.prototype.showSpinner;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
//import {FilteredTableSource} from "./filtered-table-source";
//import {finalize} from "rxjs/operators";
/** @type {?} */
var TAG$1 = 'MatTableSource';
/**
 * @abstract
 * @template E
 */
var  /**
 * @abstract
 * @template E
 */
MatTableSource = /** @class */ (function (_super) {
    __extends(MatTableSource, _super);
    function MatTableSource(paginator, sort) {
        var _this = _super.call(this) || this;
        _this.paginator = paginator;
        _this.sort = sort;
        _this.dataList = [];
        _this.status = 'loading';
        return _this;
    }
    /**
     * @return data mutations which trigger table reload
     */
    /**
     * @protected
     * @return {?} data mutations which trigger table reload
     */
    MatTableSource.prototype.initReloadMutations = /**
     * @protected
     * @return {?} data mutations which trigger table reload
     */
    function () {
        /** @type {?} */
        var dataMutations = [];
        if (this.paginator)
            dataMutations.push(this.paginator.page);
        if (this.sort)
            dataMutations.push(this.sort.sortChange);
        return dataMutations;
    };
    /**
     * @param totalRows total number of rows (without paging)
     */
    /**
     * @protected
     * @param {?} totalRows total number of rows (without paging)
     * @return {?}
     */
    MatTableSource.prototype.updatePager = /**
     * @protected
     * @param {?} totalRows total number of rows (without paging)
     * @return {?}
     */
    function (totalRows) {
        if (this.paginator) {
            this.paginator.length = totalRows;
        }
    };
    /**
     * Connect this data source to the table. The table will only update when
     * the returned stream emits new items.
     * @returns A stream of the items to be rendered.
     */
    /**
     * Connect this data source to the table. The table will only update when
     * the returned stream emits new items.
     * @return {?} A stream of the items to be rendered.
     */
    MatTableSource.prototype.connect = /**
     * Connect this data source to the table. The table will only update when
     * the returned stream emits new items.
     * @return {?} A stream of the items to be rendered.
     */
    function () {
        var _this = this;
        // Combine everything that affects the rendered data into one update
        // stream for the data-table to consume.
        /** @type {?} */
        var dataMutations = this.initReloadMutations();
        return new Observable((/**
         * @param {?} observer
         * @return {?}
         */
        function (observer) {
            merge.apply(void 0, __spread(dataMutations)).subscribe((/**
             * @return {?}
             */
            function () {
                _this.reloadTable().subscribe((/**
                 * @param {?} rows
                 * @return {?}
                 */
                function (rows) {
                    if (_this.dataList.length == 0)
                        _this.dataList = rows;
                    observer.next(_this.filterData(rows));
                }));
            }));
        }));
    };
    /**
     * @protected
     * @param {?} data
     * @return {?}
     */
    MatTableSource.prototype.pageData = /**
     * @protected
     * @param {?} data
     * @return {?}
     */
    function (data) {
        if (this.paginator != null) {
            this.paginator.length = data.length;
            /** @type {?} */
            var startIndex = this.paginator.pageIndex * this.paginator.pageSize;
            data = data.splice(startIndex, this.paginator.pageSize);
        }
        return data;
    };
    /**
     * @protected
     * @param {?} data
     * @return {?}
     */
    MatTableSource.prototype.sortData = /**
     * @protected
     * @param {?} data
     * @return {?}
     */
    function (data) {
        var _this = this;
        if (!this.sort || !this.sort.active || this.sort.direction == '') {
            return data;
        }
        return data.sort((/**
         * @param {?} a
         * @param {?} b
         * @return {?}
         */
        function (a, b) {
            var _a;
            /** @type {?} */
            var propertyA;
            /** @type {?} */
            var propertyB;
            /** @type {?} */
            var prop = _this.sort.active;
            //[propertyA, propertyB] = [a[prop], b[prop]];
            _a = __read(_this.sortValues(a, b, prop), 2), propertyA = _a[0], propertyB = _a[1];
            /** @type {?} */
            var valueA = isNaN(+propertyA) ? propertyA : +propertyA;
            /** @type {?} */
            var valueB = isNaN(+propertyB) ? propertyB : +propertyB;
            return (valueA < valueB ? -1 : 1) * (_this.sort.direction == 'asc' ? 1 : -1);
        }));
    };
    /**
     * @protected
     * @param {?} a
     * @param {?} b
     * @param {?} prop
     * @return {?}
     */
    MatTableSource.prototype.sortValues = /**
     * @protected
     * @param {?} a
     * @param {?} b
     * @param {?} prop
     * @return {?}
     */
    function (a, b, prop) {
        return [a[prop], b[prop]];
    };
    /**
     * @protected
     * @param {?} data
     * @return {?}
     */
    MatTableSource.prototype.searchData = /**
     * @protected
     * @param {?} data
     * @return {?}
     */
    function (data) {
        return data;
    };
    return MatTableSource;
}(TableDataSource));
if (false) {
    /**
     * @type {?}
     * @protected
     */
    MatTableSource.prototype.dataList;
    /**
     * @type {?}
     * @protected
     */
    MatTableSource.prototype.paginator;
    /**
     * @type {?}
     * @protected
     */
    MatTableSource.prototype.sort;
    /**
     * reload table data
     * @abstract
     * @protected
     * @return {?}
     */
    MatTableSource.prototype.reloadTable = function () { };
}
/**
 * @abstract
 * @template E
 */
var  /**
 * @abstract
 * @template E
 */
MixMatTableSource = /** @class */ (function (_super) {
    __extends(MixMatTableSource, _super);
    function MixMatTableSource(paginator, sort) {
        var _this = _super.call(this, paginator, sort) || this;
        _this.paginator = paginator;
        _this.sort = sort;
        _this.autoLoad = true;
        _this.dataSubject = new BehaviorSubject(null);
        return _this;
    }
    /**
     * @return {?}
     */
    MixMatTableSource.prototype.connect = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.serverMutations = this.initReloadMutations();
        if (this.serverMutations.length > 0) {
            merge.apply(void 0, __spread(this.serverMutations)).subscribe((/**
             * @return {?}
             */
            function () { return _this.reload(); }));
        }
        else {
            console.debug(TAG$1, "connect: autoLoad", this.autoLoad);
            if (this.autoLoad) {
                this.reload();
            }
        }
        /** @type {?} */
        var dataMutations = this.initDisplayMutations();
        return new Observable((/**
         * @param {?} observer
         * @return {?}
         */
        function (observer) {
            merge.apply(void 0, __spread(dataMutations)).subscribe((/**
             * @return {?}
             */
            function () {
                if (_this.dataSubject.value)
                    observer.next(_this.filterData(_this.dataSubject.value.slice()));
            }));
        }));
    };
    /**
     * @return {?}
     */
    MixMatTableSource.prototype.disconnect = /**
     * @return {?}
     */
    function () {
        if (this.dataSubject != null)
            this.dataSubject.complete();
        _super.prototype.disconnect.call(this);
    };
    /**
     * @protected
     * @param {?} data
     * @return {?}
     */
    MixMatTableSource.prototype.filterData = /**
     * @protected
     * @param {?} data
     * @return {?}
     */
    function (data) {
        /** @type {?} */
        var origLength = data.length;
        /** @type {?} */
        var serverMutations = this.serverMutations;
        // if(this.filterSubject && serverMutations.indexOf(this.filterSubject) == -1)
        //   data = this.searchData(data);
        if (this.sort && serverMutations.indexOf(this.sort.sortChange) == -1)
            data = this.sortData(data);
        if (this.paginator && serverMutations.indexOf(this.paginator.page) == -1)
            data = this.pageData(data);
        console.debug(TAG$1, "filterData:", data.length, "/", origLength);
        return data;
    };
    /**
     * @return {?}
     */
    MixMatTableSource.prototype.reload = /**
     * @return {?}
     */
    function () {
        var _this = this;
        console.debug(TAG$1, "reload");
        this.status = 'loading';
        this.reloadTable()
            //.pipe(finalize(() => this.status = 'ready'))
            .subscribe((/**
         * @param {?} rows
         * @return {?}
         */
        function (rows) { return _this.onLoaded(rows); }), (/**
         * @param {?} error
         * @return {?}
         */
        function (error) { return _this.onError(error, 'reload'); }));
    };
    /**
     * @protected
     * @param {?} rows
     * @return {?}
     */
    MixMatTableSource.prototype.onLoaded = /**
     * @protected
     * @param {?} rows
     * @return {?}
     */
    function (rows) {
        this.status = 'ready';
        this.dataSubject.next(rows);
    };
    /**
     * overload to setup server side mutations.
     */
    /**
     * overload to setup server side mutations.
     * @protected
     * @return {?}
     */
    MixMatTableSource.prototype.initReloadMutations = /**
     * overload to setup server side mutations.
     * @protected
     * @return {?}
     */
    function () {
        return this.findAllMutations();
    };
    /**
     * @protected
     * @return {?}
     */
    MixMatTableSource.prototype.findAllMutations = /**
     * @protected
     * @return {?}
     */
    function () {
        return _super.prototype.initReloadMutations.call(this);
    };
    /**
     * @protected
     * @return {?}
     */
    MixMatTableSource.prototype.initClientMutations = /**
     * @protected
     * @return {?}
     */
    function () {
        // remove server side mutations
        /** @type {?} */
        var remove = this.serverMutations;
        /** @type {?} */
        var dataMutations = this.findAllMutations();
        return dataMutations.filter((/**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            return remove.indexOf(item) === -1;
        }));
    };
    /**
     * @protected
     * @return {?}
     */
    MixMatTableSource.prototype.initDisplayMutations = /**
     * @protected
     * @return {?}
     */
    function () {
        /** @type {?} */
        var dataMutations = [this.dataSubject];
        dataMutations = dataMutations.concat(this.initClientMutations());
        return dataMutations;
    };
    // protected applyFilter(filter : F) {
    //   if(this.paginator && this.serverMutations.indexOf(this.paginator.page) != -1)
    //     this.applyPaginator(filter, this.paginator);
    //   if(this.sort && this.serverMutations.indexOf(this.sort.sortChange) != -1)
    //     this.applySort(filter, this.sort);
    //   this.applyKeyword(filter);
    // }
    // protected applyFilter(filter : F) {
    //   if(this.paginator && this.serverMutations.indexOf(this.paginator.page) != -1)
    //     this.applyPaginator(filter, this.paginator);
    //   if(this.sort && this.serverMutations.indexOf(this.sort.sortChange) != -1)
    //     this.applySort(filter, this.sort);
    //   this.applyKeyword(filter);
    // }
    /**
     * @protected
     * @param {?} filter
     * @param {?} paginator
     * @return {?}
     */
    MixMatTableSource.prototype.applyPaginator = 
    // protected applyFilter(filter : F) {
    //   if(this.paginator && this.serverMutations.indexOf(this.paginator.page) != -1)
    //     this.applyPaginator(filter, this.paginator);
    //   if(this.sort && this.serverMutations.indexOf(this.sort.sortChange) != -1)
    //     this.applySort(filter, this.sort);
    //   this.applyKeyword(filter);
    // }
    /**
     * @protected
     * @param {?} filter
     * @param {?} paginator
     * @return {?}
     */
    function (filter, paginator) {
        if (paginator && this.serverMutations.indexOf(paginator.page) != -1)
            _super.prototype.applyPaginator.call(this, filter, paginator);
    };
    /**
     * @protected
     * @param {?} filter
     * @param {?} sort
     * @return {?}
     */
    MixMatTableSource.prototype.applySort = /**
     * @protected
     * @param {?} filter
     * @param {?} sort
     * @return {?}
     */
    function (filter, sort) {
        if (sort && this.serverMutations.indexOf(sort.sortChange) != -1)
            _super.prototype.applySort.call(this, filter, sort);
    };
    /**
     * @param {?} paginator
     * @return {?}
     */
    MixMatTableSource.prototype.setPaginator = /**
     * @param {?} paginator
     * @return {?}
     */
    function (paginator) {
        this.paginator = paginator;
    };
    /**
     * @param {?} sort
     * @return {?}
     */
    MixMatTableSource.prototype.setSort = /**
     * @param {?} sort
     * @return {?}
     */
    function (sort) {
        this.sort = sort;
    };
    return MixMatTableSource;
}(MatTableSource));
if (false) {
    /** @type {?} */
    MixMatTableSource.prototype.dataSubject;
    /**
     * @type {?}
     * @protected
     */
    MixMatTableSource.prototype.serverMutations;
    /**
     * @type {?}
     * @protected
     */
    MixMatTableSource.prototype.autoLoad;
    /**
     * @type {?}
     * @protected
     */
    MixMatTableSource.prototype.paginator;
    /**
     * @type {?}
     * @protected
     */
    MixMatTableSource.prototype.sort;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var TAG$2 = 'FilteredTableSource';
/**
 * @abstract
 * @template F, E
 */
var  /**
 * @abstract
 * @template F, E
 */
FilteredTableSource = /** @class */ (function (_super) {
    __extends(FilteredTableSource, _super);
    function FilteredTableSource(paginator, sort, tableFilter) {
        var _this = _super.call(this, paginator, sort) || this;
        _this.paginator = paginator;
        _this.sort = sort;
        _this.tableFilter = tableFilter;
        _this.filterSubject = new BehaviorSubject(tableFilter);
        return _this;
    }
    /**
     * @return {?}
     */
    FilteredTableSource.prototype.disconnect = /**
     * @return {?}
     */
    function () {
        if (this.filterSubject != null)
            this.filterSubject.complete();
        _super.prototype.disconnect.call(this);
    };
    /**
     * @protected
     * @param {?} filter
     * @return {?}
     */
    FilteredTableSource.prototype.applyFilter = /**
     * @protected
     * @param {?} filter
     * @return {?}
     */
    function (filter) {
        this.applyPaginator(filter, this.paginator);
        this.applySort(filter, this.sort);
        this.applyKeyword(filter);
    };
    /**
     * @protected
     * @return {?}
     */
    FilteredTableSource.prototype.findAllMutations = /**
     * @protected
     * @return {?}
     */
    function () {
        /** @type {?} */
        var mutations = _super.prototype.findAllMutations.call(this);
        if (this.filterSubject)
            mutations.push(this.filterSubject);
        //console.debug(TAG, "findAllMutations: mutations", mutations.length);
        return mutations;
    };
    /**
     * @protected
     * @return {?}
     */
    FilteredTableSource.prototype.findFilter = /**
     * @protected
     * @return {?}
     */
    function () {
        /** @type {?} */
        var filter = this.filterSubject.value;
        if (!filter) {
            filter = (/** @type {?} */ ({}));
        }
        return filter;
    };
    /**
     * @protected
     * @param {?} data
     * @return {?}
     */
    FilteredTableSource.prototype.filterData = /**
     * @protected
     * @param {?} data
     * @return {?}
     */
    function (data) {
        /** @type {?} */
        var serverMutations = this.serverMutations;
        //console.debug(TAG, "filterData: serverMutations", serverMutations);
        if (this.filterSubject && serverMutations.indexOf(this.filterSubject) == -1)
            data = this.searchData(data);
        return _super.prototype.filterData.call(this, data);
    };
    return FilteredTableSource;
}(MixMatTableSource));
if (false) {
    /** @type {?} */
    FilteredTableSource.prototype.filterSubject;
    /**
     * @type {?}
     * @protected
     */
    FilteredTableSource.prototype.paginator;
    /**
     * @type {?}
     * @protected
     */
    FilteredTableSource.prototype.sort;
    /**
     * @type {?}
     * @protected
     */
    FilteredTableSource.prototype.tableFilter;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
//import {MatPaginator} from "@angular/material/paginator";
//import {MatSort} from "@angular/material/sort";
/** @type {?} */
var TAG$3 = 'QueryTableSource';
/**
 * Data source for QueryResult objects
 * (including sorting, pagination, and filtering).
 * @abstract
 * @template F, E
 */
var  /**
 * Data source for QueryResult objects
 * (including sorting, pagination, and filtering).
 * @abstract
 * @template F, E
 */
QueryTableSource = /** @class */ (function (_super) {
    __extends(QueryTableSource, _super);
    function QueryTableSource() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @protected
     * @return {?}
     */
    QueryTableSource.prototype.reloadTable = /**
     * @protected
     * @return {?}
     */
    function () {
        var _this = this;
        return this.queryTable().pipe(map((/**
         * @param {?} qr
         * @return {?}
         */
        function (qr) {
            _this.updatePager(qr.rows);
            return qr.items;
        })));
    };
    return QueryTableSource;
}(FilteredTableSource));
if (false) {
    /**
     * query table data
     * @abstract
     * @protected
     * @return {?}
     */
    QueryTableSource.prototype.queryTable = function () { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var TAG$4 = 'SearchTableSource';
/**
 * Data source for SearchResult objects
 * (including sorting, pagination, and filtering).
 * @abstract
 * @template F, E
 */
var  /**
 * Data source for SearchResult objects
 * (including sorting, pagination, and filtering).
 * @abstract
 * @template F, E
 */
SearchTableSource = /** @class */ (function (_super) {
    __extends(SearchTableSource, _super);
    function SearchTableSource() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @protected
     * @return {?}
     */
    SearchTableSource.prototype.reloadTable = /**
     * @protected
     * @return {?}
     */
    function () {
        var _this = this;
        return this.searchTable().pipe(map((/**
         * @param {?} qr
         * @return {?}
         */
        function (qr) {
            _this.updatePager(qr.total);
            return qr.rows;
        })));
    };
    return SearchTableSource;
}(FilteredTableSource));
if (false) {
    /**
     * query table data
     * @abstract
     * @protected
     * @return {?}
     */
    SearchTableSource.prototype.searchTable = function () { };
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { FilteredTableSource, MatTableSource, MixMatTableSource, QueryTableSource, SearchTableSource, TableDataSource };
//# sourceMappingURL=yukawa-chain-base-angular-store.js.map
